Subject: Re: [RFC bpf-next 0/2] bpf: Fix BTF data for modules

From: Jiri Olsa <[email-masked]>
Date: Fri, 25 Feb 2022 18:15:03 +0100

On Fri, Feb 25, 2022 at 02:19:06PM +0100, Alexander Egorenkov wrote:
> 
> Hi Jiri and Andrii,
> 
> we also have discovered this problem recently on Fedora 35 and linux-next.
> Is there any status update here ?

Andrii made the fix:
  https://lore.kernel.org/bpf/[email-masked]/

IIRC there's still some issues, but they dont have too big
impact on the size, it's discussed in that link

> 
> @Jiri
> Is the increase of total kernel modules size by 20MB really a big deal
> on s390x ? We would like to have it enabled on our architecture
> again ;-) And 20MB seems okay or am i missing something maybe ?

20M is not that much, the problem was that it's double the size
of all the modules and it was problem on rhel, where the impact
was much bigger for some reason

the fix seems to be already in fedora kernel so we could enable
BTF for s390x, I'll check on that

> 
> Another question i have wrt to BTF is why is it necessary to have e.g.
> _struct module_ be present within kernel module BTF if it is already
> present within vmlinux's one ? Can't the one from vmlinux be reused for
> kernel modules as well, they should be identical, right ?

that's basically the issue.. the dedup algo did not cover all the
cases so BTF kept both module structs because they were 'different'

jirka

> Thanks
> Regards
> Alex